/**
 * @author mer Akyol
 *         20321456
 */
import java.awt.*;
import javax.swing.*;
import javax.swing.border.BevelBorder;

import java.awt.event.*;

public class Gtahta extends JFrame implements ActionListener
{
	private static int sizeX = 500; //Default length
	private static int sizeY = 560; //Default length
	private JPanel panel;
	Buttons[][] button;
	KnightMove knight;
	private int[][] chessBoard;
	private JButton[][] bt = new JButton[8][8];
	private int count=1, a,b;
	
	private Timer animationTimer;
	protected static JLabel labelComment;
	private static int animationDelay = 1000;     
	
	public Gtahta()  
	{	
		super("KNIGHT'S TOUR");
	
		// get content pane and set layout
		Container container = getContentPane();
		container.setLayout(new FlowLayout());
		
		// create Comment Panel and it's label
		 JPanel comment = new JPanel();
		 labelComment = new JLabel("    SELECT A START SQUARE FOR KNIGHT    ");
		 comment.add(labelComment);
		 comment.setBorder( new BevelBorder(BevelBorder.LOWERED));
		 container.add(comment);
		 
		//Create buttons
		panel  = new JPanel();
		panel.setLayout(new GridLayout(8,8));
		button = new Buttons[8][8];
	
		for(int i=0; i<8; ++i){
			for(int j=0; j<8; ++j){
			    button[i][j] = new Buttons();
			    button[i][j].setXY(i,j);
			    a=i;
			    b=j;
			    bt[i][j] = button[i][j].createButton();
			   
			    if(i%2==0 && j%2==0)
			        bt[i][j].setIcon(new ImageIcon("icons/green.gif"));
			    else if((j+1)%2==0 && i%2!=0)
			        bt[i][j].setIcon(new ImageIcon("icons/green.gif"));
			    
					panel.add(bt[i][j]);
			}
		}
		
		container.add(panel);

		// create menu bar
		JMenuBar bar = new JMenuBar();
		setJMenuBar(bar);
		
		// create File menu 
		JMenu game = new JMenu("File");
		game.setMnemonic('F');
		bar.add(game);
		

		// create Exit menu item
		JMenuItem newBoard = new JMenuItem("New Board");
		newBoard.setMnemonic('N');
		game.add(newBoard);	
		newBoard.addActionListener( //Action Listener for Exit
			new ActionListener()
			{
				public void actionPerformed(ActionEvent event)
				{
					dispose();
					dispose();	
					Gtahta gt = new Gtahta();
					gt.setLocation(100,100);
					count = 1;
					Buttons.set  = false;
				}
			}
		);	
		
		// create Start menu item
		JMenuItem  start = new JMenuItem("Start Animation");
		start.setMnemonic('S');
		game.add(start);
		start.addActionListener( //Action Listener for Start
			new ActionListener()
			{
				public void actionPerformed(ActionEvent event)
				{
				    if(count == 1)
				        animate();
				    else if(count==65)
				        Gtahta.labelComment.setText("        OPEN NEW BOARD TO RESTART ( File ==> New Board )     ");
				    else
				        Gtahta.labelComment.setText("        IT IS ALREADY STARTED ! ! !      ");
				}
			}
		);
				
		game.addSeparator(); // End of button seperator
		
		// create Exit menu item
		JMenuItem exit = new JMenuItem("Exit");
		exit.setMnemonic('x');
		game.add(exit);	
		exit.addActionListener( //Action Listener for Exit
			new ActionListener()
			{
				public void actionPerformed(ActionEvent event)
				{
					System.exit(0);
				}
			}
		);	
					
		// create Help Menu
		JMenu help = new JMenu("Help");
		help.setMnemonic('H');
		bar.add(help);
			
		// create About menu item
		JMenuItem about = new JMenuItem("About");
		about.setMnemonic('A');
		help.add(about);
		about.addActionListener( //Action Listener for About
			new ActionListener()
			{
				public void actionPerformed(ActionEvent event)
				{				
					JOptionPane.showMessageDialog(Gtahta.this,"\n\n" +
					"THE KNIGHT'S TOUR Graphical Interface Version 0.1\n" +
				    "By Omer Akyol (December 2004)\n\nText Based Version" +
				    " By Garth Bruen (September 2002)\nOriginal Algorithm:" +
				    " H.C. von Warnsdorf 1823","About...",JOptionPane.PLAIN_MESSAGE);
				}
			}
		);
		
		// create How To Play menu item
		JMenuItem howToPlay = new JMenuItem("How To Play . . .");
		howToPlay.setMnemonic('o');
		help.add(howToPlay);
		howToPlay.addActionListener( //Action Listener for How To Play
			new ActionListener()
			{
				public void actionPerformed(ActionEvent event)
				{
					JOptionPane.showMessageDialog(Gtahta.this,"1- Select the " +
					"square where knight will start.\n2- Start animation and " +
			        "watch the travelling knight\n3- When finishes press \"New Board\" to reset the " +
			        "board\n","How To...",JOptionPane.PLAIN_MESSAGE);
				}
			}
		);
			
		setResizable(false);
		setSize(sizeX,sizeY);
		setVisible(true);
	}// Board()
	
	public void animate()
	{
	    chessBoard = new int[8][8];
		knight = new KnightMove();
		knight.engine();
		chessBoard = knight.getRecord();
		
		for(int i=0; i<8; ++i){
			for(int j=0; j<8; ++j){
				bt[i][j].setName(""+chessBoard[i][j]);
			}
		}
		startAnimation();
		Gtahta.labelComment.setText("        ENJOY THE SHOW    : )      ");
	}
	
	public void run()
	{
	    if((count == 64))//If count is 64 animation stops.
	    {
	        stopAnimation();
	        Gtahta.labelComment.setText("        IT'S DONE ! ! !       ");
	    }
	    
	    if(count == 32)
	        Gtahta.labelComment.setText("        BE PATIENT !   IT IS ALMOST DONE        ");
	        
	    for(int i=0; i<8; ++i){
			for(int j=0; j<8; ++j){	
			    if(bt[i][j].getName().compareTo(""+count)==0)
			    {
			        if(count>1)//To set red where knight travelled
			            bt[a][b].setIcon(new ImageIcon("icons/red.gif"));  
			        
			        a=i;
			        b=j;
			        bt[i][j].setIcon(new ImageIcon("icons/knight.gif"));
			    }
			}
        }
	    
	    count++;
	}
	
	public void startAnimation()
	{
		if(animationTimer == null)
		{	
			animationTimer = new Timer(animationDelay,this);
			animationTimer.start();
		}
	}
	
	public void stopAnimation()
	{ 
		animationTimer.stop();
	}

	public void actionPerformed(ActionEvent arg0)
	{
		run();
	}
	
}// Board Class

