/***********************************************
*
*To solve this I used Warnsdorf's approach
*which says the best move is the one that
*has has the least number of possible moves
*following that move. 
*
* This CLASS is coded by Garth Bruen
*some optimizations made by mer Akyol
*
**************************************************/

class KnightMove
{
      private int lastBoard[][]  = new int[8][8];//Last Board that will be sent to Gtahta
      private static int posX, posY; //Default starting point
      
      public void engine()
      {
          int size = 8; 

          char k = 'k'; 
          int moveCount = 1; //Initialize the move counter
          char board[][]     = new char[size][size];//Array of live board
          int storeMoves[][] = new int[size][size]; //a seperate array to store all the moves
         


          board[posX][posY] = k;
          storeMoves[posX][posY] = moveCount;
          int nextMove = 0;
          nextMove = bestMove(storeMoves, size, posX, posY);

          /*
           while conditions
           *
           *-move count should be less than the board size
           *-user can quit with 12
           *-a zero value for menuOp or 
           *nextMove indicates that no moves are left
           *
           */

          while((moveCount<(size*size))&(nextMove!=0))
          {
              moveCount++;
              switch(nextMove)
              {
              	case 0:
              	    break;
              	
              	case 1:
              	    move(size, board, posX, posY, (posX-2), (posY-1)); 
              	    break;
              	
              	case 2:
              	    move(size, board, posX, posY, (posX-2), (posY+1)); 
              	    break;
              	        
              	case 3: 
              	    move(size, board, posX, posY, (posX-1), (posY-2)); 
              	    break;
              	        
              	case 4:
              	    move(size, board, posX, posY, (posX-1), (posY+2)); 
              	    break;
              	
              	case 5:
              	    move(size, board, posX, posY, (posX+1), (posY-2)); 
              	    break;

              	case 6:
              	    move(size, board, posX, posY, (posX+1), (posY+2)); 
              	    break;
              	
              	case 7:
              	    move(size, board, posX, posY, (posX+2), (posY-1)); 
              	    break;

              	case 8:
              	    move(size, board, posX, posY, (posX+2), (posY+1)); 
              	    break;

              	default://Impossible to enter here... 
              	    System.out.println("Unknown ERROR!!!");
              		break;
              }
              
              posX = findXpos(board, size);
    	      posY = findYpos(board, size);
    	      storeMoves[posX][posY] = moveCount;
    	      nextMove = bestMove(storeMoves, size, posX, posY);
          }//end while()

          /* End Sequence 
           *Special section to handle the last move,
           *determine if the solution is found and
           *print out the results
           */

          if((moveCount==(size*size))&&(nextMove==0)){
              setRecord(storeMoves, size);
          }else{
              System.out.println("Problem unsolved");
              setRecord(storeMoves, size);
          }

          /*If there are no moves left and the
           * move count matches the size of the board
           * then we have success!
           */


      }//end Engine()


/***********************************************************************/
/***********************************************************************/

/*METHODS
 * 
*bestMove() tests the 8 differnt moves
*exploreMove() explores an individual move option
*move() actually "moves" the pieces by updating the board arrays
*resetBoard() changes the live board back to starting point
*resetRecord() changes the move record back to starting point
*findXpos() works with findYpos() to locate the live piece on the board
*findYpos() works with findXpos() to locate the live piece on the board
*printRecord() prints the record of moves
*printBoard() prints the live board
*isLegalMove() tests to see if each move is not off the board or occupied
*/

/*
* Tests various moves recursively. If a move is a legal move,
*that position is resubmitted to find the next move(s) from
*there. It continues recursively until the various moves have
*been checked.
*
*the board size and move are passed to isLegalMove()
*If it's legal the move is passed to exploreMove() to 
*see how many moves are possible from there
*The lowest moves are compared with others in the nex if statement
*/

public void setPosXPosY(int x, int y)//It is reversed because of the data struct
{
    posX=x;
    posY=y;
}
      
      
public static int bestMove(int recBoard[][], int size, int posX, int posY){
int posMoves = 0, lowestMoves = 8, bestMove = 0; boolean lastMove = false;

if(isLegalMove(recBoard, size, (posX-2), (posY-1))==true)
{
    posMoves = exploreMove(recBoard, size, (posX-2), (posY-1), lastMove);
    
    if((posMoves != 0)&&(posMoves < lowestMoves))
    {
        lowestMoves = posMoves;
        bestMove = 1;
    }
}

if(isLegalMove(recBoard, size, (posX-2), (posY+1))==true){
posMoves = exploreMove(recBoard, size, (posX-2), (posY+1), lastMove);
if((posMoves != 0)&&(posMoves < lowestMoves)){
lowestMoves = posMoves;
bestMove = 2;
}
}
if(isLegalMove(recBoard, size, (posX-1), (posY-2))==true){
posMoves = exploreMove(recBoard, size, (posX-1), (posY-2), lastMove);
if((posMoves != 0)&&(posMoves < lowestMoves)){
lowestMoves = posMoves;
bestMove = 3;
}
}
if(isLegalMove(recBoard, size, (posX-1), (posY+2))==true){
posMoves = exploreMove(recBoard, size, (posX-1), (posY+2), lastMove);
if((posMoves != 0)&&(posMoves < lowestMoves)){
lowestMoves = posMoves;
bestMove = 4;
}
}
if(isLegalMove(recBoard, size, (posX+1), (posY-2))==true){
posMoves = exploreMove(recBoard, size, (posX+1), (posY-2), lastMove);
if((posMoves != 0)&&(posMoves < lowestMoves)){
lowestMoves = posMoves;
bestMove = 5;
}
}
if(isLegalMove(recBoard, size, (posX+1), (posY+2))==true){
posMoves = exploreMove(recBoard, size, (posX+1), (posY+2), lastMove);
if((posMoves != 0)&&(posMoves < lowestMoves)){
lowestMoves = posMoves;
bestMove = 6;
}
}
if(isLegalMove(recBoard, size, (posX+2), (posY-1))==true){
posMoves = exploreMove(recBoard, size, (posX+2), (posY-1), lastMove);
if((posMoves != 0)&&(posMoves < lowestMoves)){
lowestMoves = posMoves;
bestMove = 7;
}
}
if(isLegalMove(recBoard, size, (posX+2), (posY+1))==true){
posMoves = exploreMove(recBoard, size, (posX+2), (posY+1), lastMove);
if((posMoves != 0)&&(posMoves < lowestMoves)){
lowestMoves = posMoves;
bestMove = 8;
}
}

/*Get the last legal move and check for end of game*/
if(bestMove == 0)
{
    lastMove = true;

    bestMove = exploreMove(recBoard, size, posX, posY, lastMove);
//if(bestMove != 0){
//System.out.println("This is the last legal move.");
//}
}

return bestMove;
}//end bestMove()


/*
*Explores various moves to see how many possible
*moves there are from a given position.
*The "best" move is the one that has the least options
*/



public static int exploreMove(int recBoard[][], int size, int posX, int posY, boolean lastMove){
int possMoves= 0; int moveNum = 0;

if(isLegalMove(recBoard, size, (posX-2), (posY-1))==true)
{ 
    possMoves++;
    moveNum = 1;
}

if(isLegalMove(recBoard, size, (posX-2), (posY+1))==true)
{ 
    possMoves++;
moveNum = 2;
}
if(isLegalMove(recBoard, size, (posX-1), (posY-2))==true){ possMoves++;
moveNum = 3;}
if(isLegalMove(recBoard, size, (posX-1), (posY+2))==true){ possMoves++;
moveNum = 4;}
if(isLegalMove(recBoard, size, (posX+1), (posY-2))==true){ possMoves++;
moveNum = 5;}
if(isLegalMove(recBoard, size, (posX+1), (posY+2))==true){ possMoves++;
moveNum = 6;}
if(isLegalMove(recBoard, size, (posX+2), (posY-1))==true){ possMoves++;
moveNum = 7;}
if(isLegalMove(recBoard, size, (posX+2), (posY+1))==true){ possMoves++;
moveNum = 8;}

if(lastMove==true){
possMoves = moveNum;
}
return possMoves;

}//end exploreMove()


/* 
*This method actaully executes the move, updating the live board
*/
public static char[][] move(int size, char board[][], int posX, int posY, int newX, int newY){
char k = board[posX][posY];

//System.out.println("X="+newX+", Y="+newY);
board[posX][posY] = ' ';//reset old position
board[newX][newY] = k;//set new position
return board;
}


/* 
*These two methods will reset the board and the move record
*/

public static char[][] resetBoard(char board[][], int size){
for(int i = 0; i<size; i++){
for(int j = 0; j<size; j++){
board[i][j] =' ';
}
}
board[0][0] = 'k';

return board;
}
public static int[][] resetRecord(int board[][], int size){
for(int i = 0; i<size; i++){
for(int j = 0; j<size; j++){
board[i][j] =0;
}
}
board[0][0] = 1;

return board;
}


/* 
* These two methods locate the current position of the knight
* on the live board
*/

public static int findXpos(char board[][], int size){
int posX = -1;
for(int i = 0; i < size; i++)
{
    for(int j = 0; j < size; j++)
    {
        if(board[i][j] == 'k')
        {
            posX = i;
        }
    }
}
	return posX;
}//end findXpos

public static int findYpos(char board[][], int size){
int posY = -1;
for(int i = 0; i < size; i++){
for(int j = 0; j < size; j++){
if(board[i][j] == 'k'){
posY = j;
}
}
}
return posY;
}//end findYpos

/* These two methods print the live board after each move 
*  the record of moves on demand and the final board positions
*  at the end
*/

public void setRecord(int board[][], int size)//Dont need size now
{
    lastBoard = board;
}//end printRecord()

public int[][] getRecord()
{
    return lastBoard;
}



/* This method checks to see if a move is legal.
*There are two ways a move can be illegal:
*1. It is off the board
*2. The space has already been visited
*/


	public static boolean isLegalMove(int recBoard[][], int size, int posX, int posY){
	    boolean isLegal = false;

	    if(((posX>=0)&&(posX<size))&&((posY>=0)&&(posY<size)))
	    {
	        if(recBoard[posX][posY] == 0)
	        {
	            isLegal = true;
	        }
	        else
	        {
	            isLegal = false;
	        }
	    }
	    else
	    {
	        isLegal = false;
	    }
	    

	    return isLegal;
	}//end isLegalMove()
	
}//end Knight class